/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Db4oUnit.Extensions.Fixtures
{
	public abstract class AbstractSoloDb4oFixture : Db4oUnit.Extensions.Fixtures.AbstractDb4oFixture
	{
		private Db4objects.Db4o.Ext.IExtObjectContainer _db;

		protected AbstractSoloDb4oFixture(Db4oUnit.Extensions.Fixtures.IConfigurationSource
			 configSource) : base(configSource)
		{
		}

		public sealed override void Open()
		{
			Db4oUnit.Assert.IsNull(_db);
			_db = CreateDatabase(Config()).Ext();
		}

		public override void Close()
		{
			if (null != _db)
			{
				Db4oUnit.Assert.IsTrue(Db().Close());
				_db = null;
			}
		}

		public override Db4objects.Db4o.Ext.IExtObjectContainer Db()
		{
			return _db;
		}

		protected abstract Db4objects.Db4o.IObjectContainer CreateDatabase(Db4objects.Db4o.Config.IConfiguration
			 config);

		public override Db4objects.Db4o.Internal.LocalObjectContainer FileSession()
		{
			return (Db4objects.Db4o.Internal.LocalObjectContainer)_db;
		}
	}
}
