/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Db4objects.Db4o.Tests.Common.Assorted
{
	public class FileSizeOnRollbackTestCase : Db4oUnit.Extensions.AbstractDb4oTestCase
	{
		public static void Main(string[] args)
		{
			new Db4objects.Db4o.Tests.Common.Assorted.FileSizeOnRollbackTestCase().RunSolo();
		}

		public class Item
		{
			public int _int;
		}

		public virtual void TestFileSizeDoesNotIncrease()
		{
			StoreSomeItems();
			ProduceSomeFreeSpace();
			int originalFileSize = FileSize();
			for (int i = 0; i < 100; i++)
			{
				Store(new Db4objects.Db4o.Tests.Common.Assorted.FileSizeOnRollbackTestCase.Item()
					);
				Db().Rollback();
				Db4oUnit.Assert.AreEqual(originalFileSize, FileSize());
			}
		}

		private void StoreSomeItems()
		{
			for (int i = 0; i < 3; i++)
			{
				Store(new Db4objects.Db4o.Tests.Common.Assorted.FileSizeOnRollbackTestCase.Item()
					);
			}
			Db().Commit();
		}

		private void ProduceSomeFreeSpace()
		{
			Db4objects.Db4o.IObjectSet objectSet = NewQuery(typeof(Db4objects.Db4o.Tests.Common.Assorted.FileSizeOnRollbackTestCase.Item)
				).Execute();
			while (objectSet.HasNext())
			{
				Db().Delete(objectSet.Next());
			}
			Db().Commit();
		}

		private int FileSize()
		{
			Db4objects.Db4o.Internal.LocalObjectContainer localContainer = Fixture().FileSession
				();
			Db4objects.Db4o.Internal.IoAdaptedObjectContainer container = (Db4objects.Db4o.Internal.IoAdaptedObjectContainer
				)localContainer;
			container.SyncFiles();
			long length = new Sharpen.IO.File(container.FileName()).Length();
			return (int)length;
		}
	}
}
