/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Db4objects.Db4o.Foundation
{
	/// <exclude></exclude>
	public class SortedCollection4
	{
		private readonly Db4objects.Db4o.Foundation.IComparison4 _comparison;

		private Db4objects.Db4o.Foundation.Tree _tree;

		public SortedCollection4(Db4objects.Db4o.Foundation.IComparison4 comparison)
		{
			if (null == comparison)
			{
				throw new System.ArgumentNullException();
			}
			_comparison = comparison;
			_tree = null;
		}

		public virtual object SingleElement()
		{
			if (1 != Size())
			{
				throw new System.InvalidOperationException();
			}
			return _tree.Key();
		}

		public virtual void AddAll(System.Collections.IEnumerator iterator)
		{
			while (iterator.MoveNext())
			{
				Add(iterator.Current);
			}
		}

		public virtual void Add(object element)
		{
			_tree = Db4objects.Db4o.Foundation.Tree.Add(_tree, new Db4objects.Db4o.Foundation.TreeObject
				(element, _comparison));
		}

		public virtual void Remove(object element)
		{
			_tree = Db4objects.Db4o.Foundation.Tree.RemoveLike(_tree, new Db4objects.Db4o.Foundation.TreeObject
				(element, _comparison));
		}

		public virtual object[] ToArray(object[] array)
		{
			Db4objects.Db4o.Foundation.Tree.Traverse(_tree, new _AnonymousInnerClass43(this, 
				array));
			return array;
		}

		private sealed class _AnonymousInnerClass43 : Db4objects.Db4o.Foundation.IVisitor4
		{
			public _AnonymousInnerClass43(SortedCollection4 _enclosing, object[] array)
			{
				this._enclosing = _enclosing;
				this.array = array;
			}

			internal int i = 0;

			public void Visit(object obj)
			{
				array[this.i++] = ((Db4objects.Db4o.Foundation.TreeObject)obj).Key();
			}

			private readonly SortedCollection4 _enclosing;

			private readonly object[] array;
		}

		public virtual int Size()
		{
			return Db4objects.Db4o.Foundation.Tree.Size(_tree);
		}
	}
}
