/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Db4objects.Db4o.Internal
{
	public class ObjectContainerFactory
	{
		public static Db4objects.Db4o.IObjectContainer OpenObjectContainer(Db4objects.Db4o.Config.IConfiguration
			 config, string databaseFileName)
		{
			Db4objects.Db4o.IObjectContainer oc = null;
			try
			{
				oc = new Db4objects.Db4o.Internal.IoAdaptedObjectContainer(config, databaseFileName
					);
			}
			catch (Db4objects.Db4o.Ext.DatabaseFileLockedException e)
			{
				throw;
			}
			catch (Db4objects.Db4o.Ext.ObjectNotStorableException e)
			{
				throw;
			}
			catch (Db4objects.Db4o.Ext.Db4oException e)
			{
				throw;
			}
			catch (System.Exception ex)
			{
				Db4objects.Db4o.Internal.Messages.LogErr(Db4objects.Db4o.Db4oFactory.Configure(), 
					4, databaseFileName, ex);
				return null;
			}
			Db4objects.Db4o.Internal.Platform4.PostOpen(oc);
			Db4objects.Db4o.Internal.Messages.LogMsg(Db4objects.Db4o.Db4oFactory.Configure(), 
				5, databaseFileName);
			return oc;
		}
	}
}
