/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
namespace Db4objects.Db4o.Internal.Query.Processor
{
	/// <exclude></exclude>
	public class QEMulti : Db4objects.Db4o.Internal.Query.Processor.QE
	{
		public Db4objects.Db4o.Foundation.Collection4 i_evaluators = new Db4objects.Db4o.Foundation.Collection4
			();

		internal override Db4objects.Db4o.Internal.Query.Processor.QE Add(Db4objects.Db4o.Internal.Query.Processor.QE
			 evaluator)
		{
			i_evaluators.Ensure(evaluator);
			return this;
		}

		public override bool Identity()
		{
			bool ret = false;
			System.Collections.IEnumerator i = i_evaluators.GetEnumerator();
			while (i.MoveNext())
			{
				if (((Db4objects.Db4o.Internal.Query.Processor.QE)i.Current).Identity())
				{
					ret = true;
				}
				else
				{
					return false;
				}
			}
			return ret;
		}

		internal override bool IsDefault()
		{
			return false;
		}

		internal override bool Evaluate(Db4objects.Db4o.Internal.Query.Processor.QConObject
			 a_constraint, Db4objects.Db4o.Internal.Query.Processor.QCandidate a_candidate, 
			object a_value)
		{
			System.Collections.IEnumerator i = i_evaluators.GetEnumerator();
			while (i.MoveNext())
			{
				if (((Db4objects.Db4o.Internal.Query.Processor.QE)i.Current).Evaluate(a_constraint
					, a_candidate, a_value))
				{
					return true;
				}
			}
			return false;
		}

		public override void IndexBitMap(bool[] bits)
		{
			System.Collections.IEnumerator i = i_evaluators.GetEnumerator();
			while (i.MoveNext())
			{
				((Db4objects.Db4o.Internal.Query.Processor.QE)i.Current).IndexBitMap(bits);
			}
		}

		public override bool SupportsIndex()
		{
			System.Collections.IEnumerator i = i_evaluators.GetEnumerator();
			while (i.MoveNext())
			{
				if (!((Db4objects.Db4o.Internal.Query.Processor.QE)i.Current).SupportsIndex())
				{
					return false;
				}
			}
			return true;
		}
	}
}
