/* Copyright (C) 2004 - 2006  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
using System;
using System.IO;

namespace Sharpen.IO 
{

	public abstract class StreamAdaptor 
	{

		protected Stream _stream;

		public StreamAdaptor(Stream stream) 
		{
			_stream = stream;
		}

		internal Stream UnderlyingStream 
		{
			get 
			{
				return _stream;
			}
		}

		public void Close() 
		{
			_stream.Close();
		}

#if CF_1_0 || CF_2_0
		internal Stream Buffered()
		{
			return _stream;
		}

		internal Stream Buffered(int bufferSize)
		{
			return _stream;
		}
#else
		internal Stream Buffered()
		{
			return new BufferedStream(_stream);
		}

		internal Stream Buffered(int bufferSize)
		{
			return new BufferedStream(_stream, bufferSize);
		}
#endif
	}
}
